import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;
import java.text.DecimalFormat;
import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.border.Border;


public class Menu extends JPanel{
	public static final int LARGEUR_MENU = 200;
	
	private Carte map;
	private JLabel infoCoord=null;
	private JPanel info1 = null;
	private JPanel info2 = null;
	private JScrollPane info3 = null;
	private JLabel infoXmouse=null;
	private JLabel infoYmouse=null;
	private JLabel infoDepart=null;
	private JLabel infoArrivee=null;
	private JLabel infoRueDepart=null;
	private JLabel infoRueArrivee=null;
	private JLabel infoDistance=null;
	private JTextAreaImprimer infoRuesTrajet=null;


		
	Menu(Carte _map){
		map=_map;
		map.addMouseMotionListener(new TraitementMove());
		map.addMouseListener(new TraitementClick());
		
		this.setPreferredSize(new Dimension(200,600));
		this.setLayout(new BorderLayout());
		
		//cration des bodures
		Border bord1= BorderFactory.createEmptyBorder(0,10,10,10);
		Border bord2= BorderFactory.createLoweredBevelBorder();
		Border bord=BorderFactory.createCompoundBorder(bord1, bord2);
		
		//panneau d'information 1
		info1=new JPanel();
		info1.setPreferredSize(new Dimension(LARGEUR_MENU-20,78));
		info1.setBorder(bord);
		
		//panneau d'information 2
		info2=new JPanel();
		info2.setPreferredSize(new Dimension(LARGEUR_MENU-20,188));
		info2.setBorder(bord);
		
		//panneau d'affichage des coordonnees du pointeur
		infoCoord=new JLabel();
		infoXmouse=new JLabel();
		infoYmouse=new JLabel();
		infoCoord.setPreferredSize(new Dimension(LARGEUR_MENU-30,15));
		infoXmouse.setPreferredSize(new Dimension(LARGEUR_MENU-30,15));
		infoYmouse.setPreferredSize(new Dimension(LARGEUR_MENU-30,15));
		infoCoord.setText("Coordonnes LambertII (km)");
		infoXmouse.setText("X : ");
		infoYmouse.setText("Y : ");
		
		info1.add(infoCoord);
		info1.add(infoXmouse);
		info1.add(infoYmouse);
		
		//panneau d'affichage des infos sur le dpart et l'arrive
		infoDepart=new JLabel();
		infoArrivee=new JLabel();
		infoRueDepart=new JLabel();
		infoRueArrivee=new JLabel();
		infoDepart.setPreferredSize(new Dimension(LARGEUR_MENU-30,15));
		infoArrivee.setPreferredSize(new Dimension(LARGEUR_MENU-30,15));
		infoRueDepart.setPreferredSize(new Dimension(LARGEUR_MENU-30,15));
		infoRueArrivee.setPreferredSize(new Dimension(LARGEUR_MENU-30,15));
		infoDepart.setText("Dpart : ");
		infoArrivee.setText("Arrive : ");
		
		//bouton de reset et calcul du trajet
		JButton resetTrajet=new JButton("reset");
		JButton validerTrajet=new JButton("calculer le trajet");
		JButton imprimerTrajet=new JButton("Imprimer le trajet");
		resetTrajet.setPreferredSize(new Dimension(150,18));
		validerTrajet.setPreferredSize(new Dimension(150,18));
		imprimerTrajet.setPreferredSize(new Dimension(150,18));
		resetTrajet.addActionListener(new TraitementResetTrajet());
		validerTrajet.addActionListener(new TraitementCalculTrajet());
		imprimerTrajet.addActionListener(new TraitementImpressionTrajet());
		
		infoDistance = new JLabel();
		infoDistance.setPreferredSize(new Dimension(LARGEUR_MENU-30,20));
		infoDistance.setText("Distance : ");
		
		info2.add(infoDepart);
		info2.add(infoRueDepart);
		info2.add(infoArrivee);
		info2.add(infoRueArrivee);
		info2.add(resetTrajet);
		info2.add(validerTrajet);
		info2.add(imprimerTrajet);
		info2.add(infoDistance);
		
		
		//panneau d'affichage des rues du trajet
		infoRuesTrajet=new JTextAreaImprimer();
		infoRuesTrajet.setPreferredSize(new Dimension(LARGEUR_MENU-30, 118));
		//infoRuesTrajet.setEnabled(false);
		infoRuesTrajet.setForeground(Color.BLACK);
		infoRuesTrajet.setText("Cliquer sur les points \nde la carte pour dfinir \nun dpart et une arrive.");
		
		//panneau d'information 3 : affichage des rues du trajet
		info3=new JScrollPane(infoRuesTrajet);
		//info3.setSize(180,332);
		info3.setPreferredSize(new Dimension(LARGEUR_MENU-20,82));
		info3.setBorder(bord);
		
		
		JPanel infoTrajet=new JPanel();
		infoTrajet.setLayout(new BorderLayout());
		this.add(info1, BorderLayout.NORTH);
		this.add(infoTrajet, BorderLayout.CENTER);
		infoTrajet.add(info2, BorderLayout.NORTH);
		infoTrajet.add(info3, BorderLayout.CENTER);
	}
	

	//affichage des coordonnes du pointeur sur la carte  chaque mouvement
	public class TraitementMove implements MouseMotionListener{
		public void mouseMoved(MouseEvent e){
			Convertisseur c=new Convertisseur();
			c.pxToLambert(map.xMouse,map.yMouse,map.getEchelle());
			DecimalFormat df = new DecimalFormat("####0.000"); 
			infoXmouse.setText("X : "+df.format(c.getX()));
			infoYmouse.setText("Y : "+df.format(c.getY()));
		}
		public void mouseDragged(MouseEvent e){}
	}
	
	//informations sur le dpart et l'arrive du trajet  chaque click sur la carte
	public class TraitementClick implements MouseListener{
		public void mouseClicked(MouseEvent e){
			Convertisseur c=new Convertisseur();
			DecimalFormat df = new DecimalFormat("####0.000");
			//si le point de dpart est dfini
			if(map.getAffDepart()){
				c.pxToLambert(map.getDepart().getX(),map.getDepart().getY(),map.getEchelle());
				infoDepart.setText("Dpart : ("+df.format(c.getX())+";"+df.format(c.getY())+")");
				
				if(map.getReseau().getRueByPoint(map.getDepart())!=null){
					infoRueDepart.setText(map.getReseau().getRueByPoint(map.getDepart()).getNom());
				}
				else infoRueDepart.setText("");
			}
			else{
				infoDepart.setText("Dpart : ");
				infoRueDepart.setText("");
				map.afficherTrajet(false);
				infoRuesTrajet.setText("");
				infoDistance.setText("Distance :");
			}
			//si le point d'arrive est dfini
			if(map.getAffArrivee()){
				c.pxToLambert(map.getArrivee().getX(),map.getArrivee().getY(),map.getEchelle());
				infoArrivee.setText("Arrive : ("+df.format(c.getX())+";"+df.format(c.getY())+")");
				if(map.getReseau().getRueByPoint(map.getArrivee())!=null){
					infoRueArrivee.setText(map.getReseau().getRueByPoint(map.getArrivee()).getNom());
				}
				else infoRueArrivee.setText("");
			}
			else{
				infoArrivee.setText("Arrive : ");
				infoRueArrivee.setText("");
				map.afficherTrajet(false);
				infoRuesTrajet.setText("");
				infoDistance.setText("Distance :");
			}
		}

		public void mouseEntered(MouseEvent e) {}
		public void mouseExited(MouseEvent e) {}
		public void mousePressed(MouseEvent e) {}
		public void mouseReleased(MouseEvent e) {}
	}
	
	//traitement du bouton de calcul de trajet
	public class TraitementCalculTrajet implements ActionListener{
		public void actionPerformed(ActionEvent e) {
			//si un point de dpart et un point d'arrive sont dfinis et diffrents
			if(map.getAffDepart() && map.getAffArrivee() && map.getDepart()!=map.getArrivee()){
				infoRuesTrajet.setText("");
				//nouvel objet Dijkstra
				Dijkstra dj=new Dijkstra(map.getReseau());
				
				MyPoint pt1=map.getDepart();
				MyPoint pt2=map.getArrivee();
				
				//execution de l'algorithme de Dijkstra
				dj.execute(pt1, pt2);
				
				//mise en place du trajet trouv par Dijkstra dans la carte
				map.setTrajet(dj.getTrajet().getListArcs());
				map.afficherTrajet(true);
				
				Convertisseur c=new Convertisseur();
				
				//calcul et affichage de la distance totale
				double dst=dj.getShortestDistance(pt2);
				double distanceKm=c.pxToLambertDist(dst, map.getEchelle());
				DecimalFormat df = new DecimalFormat("##0.000"); 
				infoDistance.setText("Distance : "+df.format(distanceKm)+" km");
				
				
				//affichage des rues
				for(int i=dj.getTrajet().getListRues().size()-1;i>=0;i--){
					infoRuesTrajet.append(dj.getTrajet().getListRues().get(i).getNom()+"\n");
				}
				infoRuesTrajet.setRows(dj.getTrajet().getListRues().size());
				infoRuesTrajet.invalidate();
			}
			else{
				map.afficherTrajet(false);
			}
		}
	}
	
	//traitement du bouton reset
	public class TraitementResetTrajet implements ActionListener{
		public void actionPerformed(ActionEvent e) {
			//suppression de toutes les informations affiches
			map.afficherTrajet(false);
			if(map.getAffDepart()){
				map.afficherDepart();
			}
			if(map.getAffArrivee()){
				map.afficherArrivee();
			}
			infoDepart.setText("Dpart : ");
			infoArrivee.setText("Arrive : ");
			infoDistance.setText("Distance : ");
			infoRueDepart.setText("");
			infoRueArrivee.setText("");
			infoRuesTrajet.setText("Cliquer sur les points \nde la carte pour dfinir \nun dpart et une arrive.");
		}
	}
	
	//traitement du bouton imprimerTajet
	public class TraitementImpressionTrajet implements ActionListener{
		public void actionPerformed(ActionEvent e) {
			infoRuesTrajet.insert("Dpart: "+infoRueDepart.getText()+"\nArrive: "+infoRueArrivee.getText()+"\n"+infoDistance.getText()+"\n\nTrajet:\n",0);
			infoRuesTrajet.imprimerJTextArea();	
		}
	}
}

