import java.util.ArrayList;
import java.util.List;

public class Reseau{
	private String nom;
	private ArrayList<MyPoint> listPts;
	private ArrayList<Arc> listArcs;
	private ArrayList<Rue> listRues;
	private double echelle = 7.5;
	private String cheminCarte=null;
	
	Reseau(){
		nom="";
		listPts=new ArrayList<MyPoint>();
		listArcs=new ArrayList<Arc>();
		listRues=new ArrayList<Rue>();
	}
	
	public Reseau(String _nom){
		nom=_nom;
		listPts=new ArrayList<MyPoint>();
		listArcs=new ArrayList<Arc>();
		listRues=new ArrayList<Rue>();
	}
	
	public String getNom(){
		return nom;
	}
	
	public void addPoint(MyPoint p){
		listPts.add(p);
	}
	
	public void addRue(Rue r){
		listRues.add(r);
	}	
	
	public void addArc(Arc a){
		listArcs.add(a);
	}
	
	public ArrayList<MyPoint> getListPoints(){
		return listPts;
	}
	
	public ArrayList<Rue> getListRues(){
		return listRues;
	}
	
	public ArrayList<Arc> getListArcs(){
		return listArcs;
	}
	
	public double getEchelle(){
		return echelle;
	}
	
	public void setCheminCarte(String carte){
		cheminCarte=carte;
	}
	
	public String getCheminCarte(){
		return cheminCarte;
	}
	//retourne le point du reseau dont le numero est numpt
	public MyPoint getPointByNum(int numPt){
		for(int i=0;i<listPts.size();i++){
			if(listPts.get(i).getNum()==numPt){
				return listPts.get(i);
			}
		}
		return null;
	}
	
	//retourne une rue qui contient le point pt
	public Rue getRueByPoint(MyPoint pt){
		for(int i=0;i<listRues.size();i++){
			for(int j=0;j<listRues.get(i).getListPts().size();j++){
				if(listRues.get(i).getListPts().get(j).getNum()==pt.getNum()){
					return listRues.get(i);
				}
			}
		}
		return null;
	}

	//retourne le point du reseau ayant pour coordonnes _x et _y +-10px
	public MyPoint getPointPlusProche(int _x, int _y){
		for(int i=0;i<listPts.size();i++){
			if(listPts.get(i).getX()>_x-10 && listPts.get(i).getX()<_x+10 && listPts.get(i).getY()<_y+10 && listPts.get(i).getY()>_y-10){
				return listPts.get(i);
			}
		}
		return null;
	}
	
	//retourne la longueur de l'arc du rseau possdant les points passs en parametre
	public double getDistance(MyPoint start, MyPoint end){
		if(isArc(start, end)){
			return new Arc(start, end).getLongueur();
		}
		else return 0;
	}
	
	//vrifie si un arc appartient au reseau
	private boolean isArc(MyPoint pt1, MyPoint pt2){
		for(int i=0; i<listArcs.size();i++){
			MyPoint ptd=listArcs.get(i).getDepart();
			MyPoint pta=listArcs.get(i).getArrivee();
			
			if(ptd==pt1 && pta==pt2){
				return true;
			}
			else if(ptd==pt2 && pta==pt1){
				return true;
			}
		}
		return false;
	}
	
	//retourne la liste des points relis  mp par un arc
	public List getDestinations(MyPoint mp){
		List list = new ArrayList();
		
		for(int i=0; i<listArcs.size(); i++){
			MyPoint pt1=listArcs.get(i).getDepart();
			MyPoint pt2=listArcs.get(i).getArrivee();
			
			if(pt1==mp){
				list.add(pt2);
			}
			else if(pt2==mp){
				list.add(pt1);
			}
		}
		return list;
	}
}
